Type TBullet Extends Entity
	Field angle:Float
	Field speed:Float
	Field damage
	Field phase:Float	' pyrimiseen eri kohta
	Field owner	' 0 = pelaaja, 1 = vihu
	Field border
	
	Method Update() 
		x = x + xs
		y = y + ys
		CheckCollision() 
		If x < - border Or x > WIDTH + border Or y < - border Or y > HEIGHT + border Then
			Bulletlist.Remove(Self)
		EndIf
	EndMethod
	
	Method CheckCollision()
		Local _kill = False
		If owner = 0 	' pelaajan ammus kyseess
			Local c:Vihu
			For c = EachIn Vihulist
				If c.TimeHasCome = False Then 
					If distance(x , y , c.x , c.y) < c.size Then
						c.health = c.health - damage
						c.hit = True
						Local i
						For i= 0 To 5
							TParticle.Create(x , y , Rnd( - 2 , 2) , Rnd( - 2 , 2) , 0 )
						Next 
						_kill = True
						Exit
					EndIf
				EndIf
			Next
		Else If owner = 1 Then
			Local c:TPlayer
			For c = EachIn Playerlist
				'jos pelaaja ottaa osumaa
				If game_ended = False Then
				If distance(x , y , c.x , c.y) < c.size Then
					TParticle.Create(x , y , Rnd( - 2 , 2) , Rnd( - 2 , 2) , 0 )
					c.health = c.health - damage
					_kill = True
					PlaySoundBetter(sndPlayerhit , 1.0) 
					hitflash_counter = 1.0
					Exit
				EndIf
				endif
				
			Next

		EndIf
		If _kill = True Then Bulletlist.Remove(Self)
	EndMethod
	
	Method Render()
		
		Local s# = 1 + (beat^2) * 0.3
		Select owner
		Case 0
			SetColor 255, 255, 255
			SetScale 1 , 1
			SetAlpha 1
			SetRotation angle
			DrawImage imgBullet, x, y
		Case 1
			SetColor 255 -guide_r*(1-beat),255 -guide_b*beat, 255-guide_b*beat
			SetScale s+hitflash_counter , s + hitflash_counter
			SetAlpha 1
			'SetRotation (time/3 + phase + xs * 10)
			SetRotation getangle(0,0,xs,ys)
			DrawImage imgVihuBullet , x , y
		EndSelect
	EndMethod
	
	Function Create:TBullet(_x, _y, _angle, _owner = 0) 
		Local b:TBullet = New TBullet
		Select _owner
			Case 0	'pelaajan ammukset
				b.speed = 14.5
				b.angle = _angle
				b.xs = Cos(b.angle) * b.speed
				b.ys = Sin(b.angle) * b.speed
				b.damage = 50
			Case 1	'vihujen ammukset
				b.speed = 4.0
				b.angle = _angle+Rnd(-1,1)
				b.xs = Cos(b.angle) * b.speed
				b.ys = Sin(b.angle) * b.speed
				b.damage = 100	' kaikki vihujen ammukset tappavat instana, paljon kivempaa
		EndSelect
		b.phase = Rnd(0,1)
		b.x = _x
		b.y = _y
		b.owner = _owner
		b.border = 32
		Bulletlist.AddLast(b)
	EndFunction
EndType

